<template>
  <div class="m-40 flex justify-center">

    <div
      v-if="projectRequestState === 'failed'"
      class="project-state"
    >
      {{ $t('userProfile.project.request.failed', { id }) }}
    </div>

    <div
      v-else-if="projectRequestState === 'request send'"
      class="project-state"
    >
      {{ $t('userProfile.project.request.loading') }}
    </div>

    <div v-else-if="projectRequestState === 'found'">
      <div class="p-6 w-125">
        <div class="mx-8 flex justify-around">
          <button
            class="ada-button-minor text-sm"
            type="button"
            :title="$t('userProfile.project.altAndTitle.edit')"
            v-if="projectOwnedByCurrentUser && !projectIsBeingEdited"
            @click="projectIsBeingEdited = true"
          >
            {{ $t('userProfile.project.editProject') }}
          </button>
          <p
            v-if="projectIsBeingEdited"
            class="edit-header"
          >
            {{ $t('userProfile.project.editInfo') }}
          </p>

          <div v-if="projectOwnedByCurrentUser && !projectIsBeingEdited">
            <div>
              <button
                class="ada-button-minor text-sm"
                type="button"
                :title="$t('userProfile.project.altAndTitle.moveToShowcase')"
                @click="switchShowcase"
              >
                <span v-if="project.data.showcase"> {{ $t('userProfile.project.showcase.remove') }} </span>
                <span v-else> {{ $t('userProfile.project.showcase.add') }} </span>            
              </button>
            </div>
          </div>
        </div>
        <div
          v-if="project.data.showcase && !projectIsBeingEdited && projectOwnedByCurrentUser"
          class="showcase-message"
        >
          {{ $t('userProfile.project.showcase.message') }}
        </div>

        <div class="pt-1 mt-3">
          <span
            v-if="!projectIsBeingEdited"
            class="project-name"
          >
            <span
              v-if="projectNameIsEmpty"
              class="ada-project-no-name"
            >
              {{ $t('userProfile.project.emptyName') }}
            </span>
            <span v-else> {{ project.data.name }} </span>
          </span>
                
          <div v-if="projectIsBeingEdited">
            <div class="text-xl">
              <input
                v-model="changeRequestName"
                class="being-edited"
                type="text"
                :placeholder="$t('userProfile.project.namePlaceholder')"
              >
            </div>
          </div>

          <span class="project-id" v-if="!projectIsBeingEdited">
            {{ project.data.id }}
          </span>

          <div class="w-full text-center">
            <div
              class="text-red-400"
              v-if="!validProjectName && projectIsBeingEdited"
            >
              {{ $t('userProfile.project.nameCondition') }}
            </div>
          </div>
        </div>

        <div class="mb-4" v-if="!projectIsBeingEdited">
          <span class="project-by">
              {{ $t('userProfile.project.author') }}
            <router-link
              :to="`/people/${project.data.owner.id}`"
              class="user-link"
            >
              {{ project.data.ownerData.name }}
            </router-link>
            <span
              :title="lastModifiedLocal"
              class="project-date"
            >
              {{ lastModifiedLocalShort }}
            </span>
          </span>
        </div>

        <div class="relative mt-8">
          <ProjectScreenshot :project="project" width="450"/>        
          <div
            v-if="projectIsBeingEdited"
            class="absolute bottom-0 right-0 mb-1"
          >
            <!-- The actual input to actually get the file. But not displayed.
            It will be triggerred by the following button which layout can be
            customized -->
            <input
              ref="screenshotFileInput"
              type="file"
              accept="image/*"
              @input="setScreenshot"
              style="display:none"
            >
            <!-- The button to trigger the invisible input element above. -->
            <button
              class="ada-button-overlay"
              @click="$refs.screenshotFileInput.click()"
            >
              {{ $t('userProfile.actions.imgModify') }}
            </button>
          </div>
        </div>

        <div class="my-6 pt-1 max-w-md text-xl text-gray-700">
          <p
            v-if="!projectIsBeingEdited"
            class="abstract-zone"
          >
            <span
              v-if="project.data.abstract === '' && projectOwnedByCurrentUser"
              class="empty-abstract"
            >
              {{ $t('userProfile.project.emptyDescription') }}
            </span>
            <span
              v-if="project.data.abstract === '' && !projectOwnedByCurrentUser"
              class="empty-abstract"
            >
              {{ $t('userProfile.project.emptyText') }}
            </span>
            <span class="abstract">
              {{ project.data.abstract }}
            </span>
          </p>

          <div class="md:flex md:items-center mb-6" v-if="projectIsBeingEdited">
            <div class="text-xl w-full">
              <textarea
                v-model="changeRequestAbstract"
                class="being-edited"
                style="height: 128px;"
                type="text"
                :placeholder="$t('userProfile.project.decriptionPlaceholder')"
              />
            </div>
          </div>

          <div v-if="projectOwnedByCurrentUser && projectIsBeingEdited" class="flex justify-center mb-8">
            <div
              v-if="project.data.trash"
              class="trash-desc"
            >
              <span class="trash-warning"> {{ $t('userProfile.project.trash.warning') }} </span>
                {{ $t('userProfile.project.trash.status') }}
            </div>
            <div class="mb-5">
              <button
                class="ada-button-minor text-sm"
                type="button"
                :title="$t('userProfile.project.altAndTitle.moveToTrash')"
                @click="switchTrash"
              >
                <span v-if="project.data.trash"> {{ $t('userProfile.project.trash.action.restore') }} </span>
                <span v-else> {{ $t('userProfile.project.trash.action.delete') }} </span>            
              </button>
            </div>
          </div>

          <div
            v-if="projectIsBeingEdited"
            class="valid-abort-buttons"
          >
            <button
              class="ada-button"
              type="button"
              @click="applyChanges"
            >
              {{ $t('userProfile.project.actions.apply') }}
            </button>
            <button
              class="ada-button"
              @click="cancelChanges"
            >
              {{ $t('userProfile.project.actions.cancel') }}
            </button>
          </div>
        </div>

        <div v-if="!projectIsBeingEdited">
          <div>
            <a :href="`/player?project=${project.data.id}`">
              <button
                class="ada-button mb-4"
                type="button"
                :title="$t('userProfile.project.altAndTitle.openPlayer')"
              >
                {{ $t('userProfile.project.actions.play') }}
              </button>
            </a>
          </div>
          <a :href="`/studio?project=${project.data.id}`">
            <button
              class="ada-button"
              type="button"
              :title="$t('userProfile.project.altAndTitle.openStudio')"
            >
              {{ $t('userProfile.project.actions.open') }}
            </button>
          </a>
          <div v-if="userIsLoggedIn">
            <router-link :to="getRemixUrl(project)">
              <button
                class="ada-button my-4"
                type="button"
                :title="$t('userProfile.project.altAndTitle.createRemix')"
              >
                <span> {{ $t('userProfile.project.actions.remix') }} </span>
              </button>
            </router-link>
          </div>

          <div class="featured">

              {{ $t('userProfile.project.featuredText') }}

            <a
              class="ada-link"
              target="_blank"
              rel="noopener noreferrer"
              :href="featuredSuggestionUrl"
            >
              {{ $t('userProfile.project.featuredSuggestion') }}
            </a>

          </div>

          <HorizontalLine/>

          <div class="max-w-md">
            <ProjectEmbedSettings :uid="project.data.id"></ProjectEmbedSettings>
          </div>

          <HorizontalLine/>

          <TheProjectHistory
            v-if="projectOwnedByCurrentUser"
            :project="project.data.id"
            :storageProject="project.data"
          />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { computed, ref, watch } from 'vue'
import { useTitle } from '@vueuse/core'
import { useStore, useProject, useSubmitProjectInfo } from '../store.js'
import ProjectScreenshot from '../components/ProjectScreenshot.vue'
import ProjectEmbedSettings from '../components/ProjectEmbedSettings.vue'
import TheProjectHistory from '../components/TheProjectHistory.vue'
import HorizontalLine from './HorizontalLine.vue'
import { adacraftStorageUrl } from '../config'
import { getLocalDate } from '../utils'

function projectNameIsValid(string) {
  const validProjectNameLength = /[a-zA-Z0-9-_@$*!?%#áàâäãåçéèêëíìîïñóòôöõúùûüýÿæœÁÀÂÄÃÅÇÉÈÊËÍÌÎÏÑÓÒÔÖÕÚÙÛÜÝŸÆŒ]{1,128}/gm
  return validProjectNameLength.test(string)
}

export default {
  name: 'ThePageProject',
  components: {
    ProjectScreenshot,
    ProjectEmbedSettings,
    HorizontalLine,
    TheProjectHistory
  },
  props: {
    id: {
      type: String,
      required: true
    }
  },
  setup (props) {
    const title = useTitle()
    const { userIsLoggedIn, currentUserId } = useStore()
    const { project, projectRequestState } = useProject(props.id)
    const { submitProjectInfo } = useSubmitProjectInfo()

    let projectIsBeingEdited = ref(false)

    const changeRequestName = ref('')
    watch(() => project.data.name, (name) => {
      changeRequestName.value = name
      title.value = `${name} on adacraft`
    })

    const changeRequestAbstract = ref('')
    watch(() => project.data.abstract, (abstract) => {
      changeRequestAbstract.value = abstract
    })

    // Save in an array initial image to display if user cancels changements
    const saveInitialImage = []
    const setInitialImage = () => {
      saveInitialImage.push(project.data.image)
    }
    
    // Push saveInitialImage first result in initialImage variable
    const initialImage = computed(() => (saveInitialImage[0]))

    const submitNewProjectInfo = async (info) => {
      const projectData = await submitProjectInfo(props.id, info)
      project.data = projectData
    }

    const projectOwnedByCurrentUser = computed(
      () => (
        userIsLoggedIn
        && project.data.owner.id === currentUserId.value
      )
    )

    const projectNameIsEmpty = computed(
      () => project.data.name.trim().length === 0
    )

    const validProjectName = computed(() => (projectNameIsValid(changeRequestName.value)))

    const featuredSuggestionUrl = computed(() => {
      const baseUrl =
        projectOwnedByCurrentUser.value
          ? 'https://tally.so/r/nW10e3'
          : 'https://tally.so/r/m6MxAn' 
      return `${baseUrl}?project=${props.id}`
    })

    const lastModifiedLocal = computed(
      () => getLocalDate(project.data.lastModified)
    )

    const lastModifiedLocalShort = computed(
      () => lastModifiedLocal.value.format('MMM, D YYYY')
    )

    return {
      projectRequestState,
      project,
      projectOwnedByCurrentUser,
      userIsLoggedIn,
      projectIsBeingEdited,
      changeRequestName,
      changeRequestAbstract,
      initialImage,
      setInitialImage,
      submitNewProjectInfo,
      projectNameIsEmpty,
      validProjectName,
      featuredSuggestionUrl,
      lastModifiedLocal,
      lastModifiedLocalShort
    }
  },
  methods: {
    submitNewName () {
      this.submitNewProjectInfo({
        name: this.changeRequestName
      })
    },
    submitNewDescription () {
      this.submitNewProjectInfo({
        abstract: this.changeRequestAbstract
      })
    },
    submitNewImage () {
      this.submitNewProjectInfo({
        image: this.project.data.image
      })
    },
    applyChanges () {
      if (this.changeRequestName !== this.project.data.name) {
        this.submitNewName()
      }
      if (this.changeRequestAbstract !== this.project.data.abstract) {
        this.submitNewDescription()
      }
      if (this.initialImage !== this.project.data.image) {
        this.submitNewImage()
      }
      this.projectIsBeingEdited = false
    },
    cancelChanges () {
      this.changeRequestName = this.project.data.name
      this.changeRequestAbstract = this.project.data.abstract
      this.setInitialImage()
      this.project.data.image = this.initialImage
      this.projectIsBeingEdited = false
    },
    switchTrash () {
      const newTrashValue = ! this.project.data.trash
      this.submitNewProjectInfo({
        trash: newTrashValue
      })
    },
    switchShowcase () {
      const newShowcaseValue = ! this.project.data.showcase
      this.submitNewProjectInfo({
        showcase: newShowcaseValue
      })
    },
    getRemixUrl(project) {
      const queryParams = [
        `from=${project.data.id}`
      ]
      return `/add-project?${queryParams.join('&')}`
    },
    setScreenshot () {
      this.setInitialImage()
      const file = this.$refs.screenshotFileInput.files[0]
      if (!file.type.startsWith('image/')) {
        alert(
          `The screenshot must be an image (you have selected the file ` +
          `"${file.name}" which type is "${file.type}").\n` +
          `\n` +
          `Please choose another file.`
        )
      } else {
        const imageUrl = `${adacraftStorageUrl}/projects/${this.project.data.id}_data/images/${file.name}`
        fetch(imageUrl, {
            "credentials": "omit",
            "headers": {
                "Accept": "*/*",
                'Content-Type': file.type
            },
            "body": file,
            "method": "PUT",
            "mode": "cors"
        }).then(response => {
          this.project.data.image = imageUrl
        })
        .catch((error) => {
          console.log(`error while submitting the new screenshot: ` + error)
        })
      }
    }
  }
}
</script>

<style lang="postcss" scoped>
.project-state {
  @apply dark:text-gray-300;
}

.edit-header {
  @apply mb-3;
  @apply text-xl text-gray-700;
  @apply dark:text-gray-300;
}

.showcase-message {
  @apply mt-5 mb-8;
  @apply text-base text-center italic text-gray-600;
  @apply dark:text-gray-400;
}

.project-name {
  @apply text-xl text-gray-900 leading-tight;
  @apply dark:text-gray-300;
}

.being-edited {
  @apply appearance-none;
  @apply w-full py-2 px-4;
  @apply text-gray-700;
  @apply bg-white;
  @apply border-2 border-purple-500 rounded;
  @apply outline-none;
}

.project-id {
  @apply ml-6;
  @apply leading-normal;
  @apply text-xs text-gray-400;
  @apply dark:text-gray-500;
}

.project-by {
  @apply text-gray-600 leading-tight;
  @apply dark:text-gray-400;
}

.user-link {
  @apply font-bold;
  @apply dark:text-gray-300;
}

.user-link:hover {
  @apply text-purple-400;
}

.project-date {
  @apply ml-5;
  @apply text-sm;
  @apply text-gray-400;
}

.abstract-zone {
  @apply mt-3 h-48;
  @apply leading-normal;
  @apply overflow-auto;
}

.abstract-zone::-webkit-scrollbar {
  @apply w-4;
}

.abstract-zone::-webkit-scrollbar-track {
  @apply bg-white;
  @apply dark:bg-gray-800;
}

.abstract-zone::-webkit-scrollbar-thumb {
  @apply bg-gray-400;
  @apply dark:bg-gray-400;
  @apply border-solid border-4 border-white;
  @apply dark:border-gray-800;
  @apply rounded-xl;
}

.empty-abstract {
  @apply text-gray-400;
  @apply dark:text-gray-500;
}

.abstract {
  @apply whitespace-pre-wrap;
  @apply text-gray-900;
  @apply dark:text-gray-300;
}

.trash-desc {
  @apply mr-5 mb-8;
  @apply text-lg text-gray-600;
  @apply dark:text-gray-300;
}

.trash-warning {
  @apply mr-2;
  @apply text-purple-400 font-bold;
}

.valid-abort-buttons {
  @apply w-full;
  @apply md:flex md:justify-around md:items-center;
}

.featured {
  @apply mt-10 max-w-md;
  @apply text-xl text-gray-700;
  @apply dark:text-gray-300;
}
</style>